'Edge DOS GUI Version 0.6
'Kyle McInnes - kyle@mcinnes.uk.net
'Source Code
DECLARE FUNCTION controldown% (id%)
DECLARE SUB GifLoad (a$)
DECLARE SUB togglepanel ()
DECLARE SUB drawcontrol (id%)
DECLARE SUB waits (time%)
DECLARE SUB init3 ()
DECLARE SUB Handler ()
DECLARE SUB Viewedg (file$, vix%, viy%)
DECLARE SUB init1 ()
DECLARE SUB ParseHeader (file$, winno%)
DECLARE SUB exitgui ()
DECLARE SUB Parser (file$, winno%)
DECLARE SUB putwin (win%)
DECLARE SUB putline (win%, ddo%)
DECLARE SUB Windower ()
DECLARE SUB Windo (x1%, y1%, x2%, y2%, title$, awon%)
DECLARE SUB taskbar ()
DECLARE SUB Font (txt$, x%, y%, c%, FontFile$, Attribs%)
DECLARE SUB init2 ()
DECLARE FUNCTION MouseInit% ()
DECLARE SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
DECLARE SUB MouseRange (x1%, y1%, x2%, y2%)
DECLARE SUB MousePut (x%, y%)
DECLARE SUB MouseHide ()
DECLARE SUB MouseDriver (ax%, bx%, cx%, dx%)
DECLARE SUB MouseShow ()
DEFINT A-Z: DEF SEG = &HA000:
TYPE FontCharInfo
     CharWidth AS INTEGER
     CharHeight AS INTEGER
     FileOffset AS LONG
END TYPE

CONST ATTRIB.BOLD = 1, ATTRIB.UNDERLINE = 2, ATTRIB.ITALICS = 4
CONST ALIGN.CENTER = -1, ALIGN.RIGHT = -2

DIM SHARED mouse$: mouse$ = SPACE$(57)                     'mouse
DIM SHARED lb, rb, x, y, key$                              'mouse + keyb
DIM SHARED screenresx, screenresy                          'fonts
DIM SHARED wins, winap$(2)                                 'windowing/parser
DIM SHARED winx1(2), winy1(2), wint$(2), winx2(2), winy2(2)'windowing/parser
DIM SHARED awin, grab, ox, oy                              'windowing
DIM SHARED distx, disty, distx2, disty2                    'windowing
DIM SHARED abicons$(10), abfunc$(10), abno                 'appbar
DIM SHARED openfile(2)                                     'parser
DIM SHARED guicols(10)                                     'colours
DIM SHARED controlx1(50), controly1(50)                    'control stuff
DIM SHARED controlx2(50), controly2(50)
DIM SHARED controltype(50), controlwin(50)
DIM SHARED controlstate(50), states(10)
DIM SHARED controlmsg$(50), doIF
ON ERROR GOTO Errorhandle:

init1                                   'reads config files
respoint: init2                         'sets up grahpics + autoexec

DO
'fps% = fps% + 1                        'this is just some debug code
'IF starttime# + 1 < TIMER THEN         'to show the FPS count and some
' fps2% = fps%                          'states.
' fps% = 0
' starttime# = TIMER
'END IF
'LOCATE 1, 8: PRINT fps2%; states(1); controlstate(2)

MouseStatus lb, rb, x, y
key$ = INKEY$

Handler
Windower

FOR nb = 1 TO wins
Parser winap$(nb), nb
NEXT nb

LOOP

Errorhandle:
OPEN "ini\errors.ini" FOR INPUT AS #30
DO
INPUT #30, msg$
IF VAL(LEFT$(msg$, 3)) = ERR THEN EXIT DO
LOOP UNTIL EOF(30)
CLS
IF EOF(30) THEN
 PRINT "An unkown error has occurred."
 PRINT "Code"; ERR
 PRINT "Data may have been lost."
 PRINT "Press a key to attempt to continue."
ELSE
 PRINT "An error has occured."
 PRINT msg$
 PRINT "Data may have been lost."
 PRINT "Press a key to attempt to continue."
END IF
SLEEP
CLOSE #30
RESUME respoint

DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
DATA 8B,5E,06,89,17,5D,CA,08,00
RESTORE

FUNCTION controldown (id)

IF controlx1(id) = 0 THEN EXIT FUNCTION
IF controlwin(id) <> awin THEN EXIT FUNCTION
IF lb% = -1 AND x > controlx1(id) AND y > controly1(id) AND x < controlx2(id) AND y < controly2(id) THEN
 IF controlstate(id) = 0 THEN controlstate(id) = 1: drawcontrol id
 controldown = 1
ELSE
 IF controlstate(id) = 1 THEN controlstate(id) = 0: drawcontrol id
 controldown = 0
END IF









END FUNCTION

SUB drawcontrol (id)

SELECT CASE controltype(id)
 CASE 1
  IF controlstate(id) = 0 THEN a = 7: B = 3 ELSE a = 3: B = 7
  LINE (controlx1(id), controly1(id))-(controlx2(id), controly2(id)), 0, B
  LINE (controlx1(id) + 1, controly1(id) + 1)-(controlx1(id) + 1, controly2(id) - 2), a
  LINE (controlx1(id) + 2, controly1(id) + 1)-(controlx2(id) - 1, controly1(id) + 1), a
  LINE (controlx1(id) + 1, controly2(id) - 1)-(controlx2(id) - 1, controly2(id) - 1), B
  LINE (controlx2(id) - 1, controly1(id) + 1)-(controlx2(id) - 1, controly2(id) - 1), B
  Font controlmsg$(id), controlx1(id) + 1, controly1(id) + 1, 0, "mssans", 0
END SELECT



END SUB

SUB exitgui
'exitgui: cleans up, does the shade thing and exits.
'finished.

MouseHide

LINE (0, 0)-(639, 479), guicols(1), BF
taskbar

FOR y = 0 TO 479
LINE (0 + (y MOD 2), y)-(639 + (y MOD 2), y), 0, , &HAAAA
NEXT y
Windo 170, 165, 480, 315, "Shutting Down..", 1

Font "Closing open files..", 172, 185, 0, "mssans", 0
CLOSE
SLEEP 1

SCREEN 0

END
END SUB

DEFSNG A-Z
SUB Font (txt$, x%, y%, c%, FontFile$, Attribs%)
'WinFontsQB by Josh Heaton
'font: displays a string of text.


' $b toggles bold
' $u toggles underlining
' $i toggles italics
' $$ prints 1 $
' $c changes text color at draw-time

DIM Char AS FontCharInfo
OrgAttribs% = Attribs%


a% = INSTR(FontFile$, ".")
IF a% = 0 THEN FontFile$ = FontFile$ + ".fnt"
FontFile$ = "fonts\" + FontFile$

Handle = FREEFILE
OPEN FontFile$ FOR BINARY AS #Handle
     IF LOF(Handle) = 0 THEN
        CLOSE #Handle
        KILL FontFile$
        EXIT SUB
     END IF

     Version% = 0
     GET #Handle, , Version%
     IF (Version% MOD 256 <> 0) OR (Version% \ 256 <> 1) THEN
        'Incorrect version
        CLOSE #Handle
        EXIT SUB
     END IF

     ty& = y%
     
     IF x% = ALIGN.CENTER THEN
        tx& = 0
        Widest& = 0
        FixLR% = 0
        FOR i% = 1 TO LEN(txt$)
            CharCnt% = ASC(MID$(txt$, i%, 1)) - 32
            IF CharCnt% = -19 THEN
               IF tx& > Widest& THEN Widest& = tx&: tx& = 0
               FixLR% = 1
              ELSEIF CharCnt% = ASC("$") - 32 THEN
               'Special formatting code
               i% = i% + 1
               Code$ = LCASE$(MID$(txt$, i%, 1))
               'IF code$ = "b" THEN GOSUB ToggleBold       ' Don't run these
               'IF code$ = "u" THEN GOSUB ToggleUnderline  ' on centering
               'IF code$ = "i" THEN GOSUB ToggleItalics    ' just yet...
               IF Code$ = "$" THEN
                  'Crank out a dollar sign on the screen
                  CharCnt% = ASC("$") - 32
                  GOTO CountCharWidthForCentering:
                                                  
               END IF
              ELSE
CountCharWidthForCentering:
               SEEK #Handle, (2 + 2 + 4) * CharCnt% + 1 + 2
               GET #Handle, , Char
               tx& = tx& + Char.CharWidth
            END IF
        NEXT
        IF tx& > Widest& THEN Widest& = tx&
        tx& = (screenresx \ 2) - (tx& \ 2)
       ELSEIF x% = ALIGN.RIGHT THEN
        tx& = 0
        Widest& = 0
        FixLR% = 0
        FOR i% = 1 TO LEN(txt$)
            CharCnt% = ASC(MID$(txt$, i%, 1)) - 32
            IF CharCnt% = -19 THEN
               IF tx& > Widest& THEN Widest& = tx&: tx& = 0
               FixLR% = 1
              ELSEIF CharCnt% = ASC("$") - 32 THEN
               'Special formatting code
               i% = i% + 1
               Code$ = LCASE$(MID$(txt$, i%, 1))
               IF Code$ = "$" THEN
                  'Crank out a dollar sign on the screen
                  CharCnt% = ASC("$") - 32
                  GOTO CountCharWidthForRight:
               END IF
              ELSE
CountCharWidthForRight:
               SEEK #Handle, (2 + 2 + 4) * CharCnt% + 1 + 2
               GET #Handle, , Char
               tx& = tx& + Char.CharWidth
            END IF
        NEXT
        IF tx& > Widest& THEN Widest& = tx&
        tx& = screenresx - tx&
       ELSE
        tx& = x%
     END IF
     ttx& = tx&
     FOR i% = 1 TO LEN(txt$)
         CharCnt% = ASC(MID$(txt$, i%, 1))
         FixLR% = 0
         IF CharCnt% = 13 THEN
            'Line return, fix it
            FixLR% = 1
            CharCnt% = ASC("A") - 32
           ELSEIF CharCnt% = ASC("$") THEN
            'Special formatting code
            i% = i% + 1
            Code$ = LCASE$(MID$(txt$, i%, 1))
            IF Code$ = "b" THEN GOSUB ToggleBold: CharCnt% = -1
            IF Code$ = "u" THEN GOSUB ToggleUnderline: CharCnt% = -1
            IF Code$ = "i" THEN GOSUB ToggleItalics: CharCnt% = -1
            IF Code$ = "c" THEN GOSUB SetTempColor: CharCnt% = -1
           
            IF Code$ = "$" THEN
               'Crank out a dollar sign on the screen
               CharCnt% = ASC("$") - 32
            END IF
           ELSEIF CharCnt% < 32 OR CharCnt% > 126 THEN
            CharCnt% = 127
           ELSE
            CharCnt% = CharCnt% - 32
         END IF
         IF CharCnt% > -1 THEN
            SEEK #Handle, (2 + 2 + 4) * CharCnt% + 1 + 2
            GET #Handle, , Char
            SEEK #Handle, Char.FileOffset
            REDIM CharDat&(Char.CharHeight)
            IF FixLR% <> 0 THEN
               'Do a line return
               ttx& = tx&
               ty& = ty& + Char.CharHeight
               FixLR% = 0
              ELSE
               'Draw char on screen
               IF CharCnt% <> 0 THEN
                  'Don't draw a space because there is a bug for some reason.
                  FOR cty% = 0 TO Char.CharHeight - 1
                      t% = 0
                      GET #Handle, , t%
                      CharDat&(cty%) = t%
                      offset% = 0
                      IF (Attribs% AND ATTRIB.ITALICS) <> 0 THEN offset% = -cty% / 3
                      LINE (ttx& + offset%, ty& + cty%)-(ttx& + 16 + offset%, ty& + cty%), c%, , CharDat&(cty%)' MOD 32767
                      IF (Attribs% AND ATTRIB.BOLD) <> 0 THEN
                         LINE (ttx& + offset% + 1, ty& + cty%)-(ttx& + 17 + offset%, ty& + cty%), c%, , CharDat&(cty%)' MOD 32767
                      END IF
                  NEXT
               END IF
               IF (Attribs% AND ATTRIB.UNDERLINE) <> 0 THEN LINE (ttx&, Char.CharHeight - 2 + ty&)-(ttx& + Char.CharWidth, Char.CharHeight - 2 + ty&), c%
               ttx& = ttx& + Char.CharWidth
            END IF
         END IF
     NEXT

CLOSE #Handle

Attribs% = OrgAttribs%

EXIT SUB

ToggleBold:

IF (Attribs% AND ATTRIB.BOLD) <> 0 THEN
   Attribs% = Attribs% - ATTRIB.BOLD
  ELSE
   Attribs% = Attribs% + ATTRIB.BOLD
END IF

RETURN

ToggleUnderline:

IF (Attribs% AND ATTRIB.UNDERLINE) <> 0 THEN
   Attribs% = Attribs% - ATTRIB.UNDERLINE
  ELSE
   Attribs% = Attribs% + ATTRIB.UNDERLINE
END IF

RETURN

ToggleItalics:

IF (Attribs% AND ATTRIB.ITALICS) <> 0 THEN
   Attribs% = Attribs% - ATTRIB.ITALICS
  ELSE
   Attribs% = Attribs% + ATTRIB.ITALICS
END IF

RETURN

SetTempColor:

clr$ = ""

i% = i% + 1 'Get past the "c"

WHILE INSTR("0123456789", MID$(txt$, i%, 1))
      clr$ = clr$ + MID$(txt$, i%, 1)
      i% = i% + 1
WEND

i% = i% - 1   'Back up one char

c% = VAL(clr$)

RETURN

END SUB

SUB GifLoad (a$)
DEFINT A-Z
DIM Prefix(4095), Suffix(4095), OutStack(4095), shiftout%(8)
DIM Ybase AS LONG, powersof2(11) AS LONG, WorkCode AS LONG

FOR a% = 0 TO 7: shiftout%(8 - a%) = 2 ^ a%: NEXT a%
FOR a% = 0 TO 11: powersof2(a%) = 2 ^ a%: NEXT a%
IF a$ = "" THEN INPUT "GIF file"; a$: IF a$ = "" THEN END
IF INSTR(a$, ".") = 0 THEN a$ = a$ + ".gif"
OPEN a$ FOR BINARY AS #1
a$ = "      ": GET #1, , a$

GET #1, , TotalX: GET #1, , TotalY: GOSUB GetByte
NumColors = 2 ^ ((a% AND 7) + 1): NoPalette = (a% AND 128) = 0
GOSUB GetByte: Background = a%
GOSUB GetByte: IF a% <> 0 THEN PRINT "Bad screen descriptor.": END
IF NoPalette = 0 THEN P$ = SPACE$(NumColors * 3): GET #1, , P$
DO
    GOSUB GetByte
    IF a% = 44 THEN
        EXIT DO
    ELSEIF a% <> 33 THEN
        PRINT "Unknown extension type.": END
    END IF
    GOSUB GetByte
    DO: GOSUB GetByte: a$ = SPACE$(a%): GET #1, , a$: LOOP UNTIL a% = 0
LOOP
GET #1, , XStart: GET #1, , YStart: GET #1, , XLength: GET #1, , YLength
XEnd = XStart + XLength: YEnd = YStart + YLength: GOSUB GetByte
IF a% AND 128 THEN PRINT "Can't handle local colormaps.": END
Interlaced = a% AND 64: PassNumber = 0: PassStep = 8
GOSUB GetByte
ClearCode = 2 ^ a%
EOSCode = ClearCode + 1
FirstCode = ClearCode + 2: NextCode = FirstCode
StartCodeSize = a% + 1: CodeSize = StartCodeSize
StartMaxCode = 2 ^ (a% + 1) - 1: MaxCode = StartMaxCode

BitsIn = 0: BlockSize = 0: BlockPointer = 1
x% = XStart: y% = YStart: Ybase = y% * 320&

SCREEN 13: DEF SEG = &HA000
IF NoPalette = 0 THEN
    OUT &H3C7, 0: OUT &H3C8, 0
    FOR a% = 1 TO NumColors * 3: OUT &H3C9, ASC(MID$(P$, a%, 1)) \ 4: NEXT a%
END IF
LINE (0, 0)-(319, 199), Background, BF
DO
    GOSUB GetCode
    IF Code <> EOSCode THEN
        IF Code = ClearCode THEN
            NextCode = FirstCode
            CodeSize = StartCodeSize
            MaxCode = StartMaxCode
            GOSUB GetCode
            CurCode = Code: LastCode = Code: LastPixel = Code
            IF x% < 320 THEN POKE x% + Ybase, LastPixel
            x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLine
        ELSE
            CurCode = Code: StackPointer = 0
            IF Code > NextCode THEN EXIT DO
            IF Code = NextCode THEN
                CurCode = LastCode
                OutStack(StackPointer) = LastPixel
                StackPointer = StackPointer + 1
            END IF

            DO WHILE CurCode >= FirstCode
                OutStack(StackPointer) = Suffix(CurCode)
                StackPointer = StackPointer + 1
                CurCode = Prefix(CurCode)
            LOOP

            LastPixel = CurCode
            IF x% < 320 THEN POKE x% + Ybase, LastPixel
            x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLine

            FOR a% = StackPointer - 1 TO 0 STEP -1
                IF x% < 320 THEN POKE x% + Ybase, OutStack(a%)
                x% = x% + 1: IF x% = XEnd THEN GOSUB NextScanLine
            NEXT a%

            IF NextCode < 4096 THEN
                Prefix(NextCode) = LastCode
                Suffix(NextCode) = LastPixel
                NextCode = NextCode + 1
                IF NextCode > MaxCode AND CodeSize < 12 THEN
                    CodeSize = CodeSize + 1
                    MaxCode = MaxCode * 2 + 1
                END IF
            END IF
            LastCode = Code
        END IF
    END IF
LOOP UNTIL DoneFlag OR Code = EOSCode
'BEEP
'A$ = INPUT$(1)
CLOSE #1
EXIT SUB

GetByte: a$ = " ": GET #1, , a$: a% = ASC(a$): RETURN

NextScanLine:
    IF Interlaced THEN
        y% = y% + PassStep
        IF y% >= YEnd THEN
            PassNumber = PassNumber + 1
            SELECT CASE PassNumber
            CASE 1: y% = 4: PassStep = 8
            CASE 2: y% = 2: PassStep = 4
            CASE 3: y% = 1: PassStep = 2
            END SELECT
        END IF
    ELSE
        y% = y% + 1
    END IF
    x% = XStart: Ybase = y% * 320&: DoneFlag = y% > 199
RETURN
GetCode:
    IF BitsIn = 0 THEN GOSUB ReadBufferedByte: LastChar = a%: BitsIn = 8
    WorkCode = LastChar \ shiftout%(BitsIn)
    DO WHILE CodeSize > BitsIn
        GOSUB ReadBufferedByte: LastChar = a%
        WorkCode = WorkCode OR LastChar * powersof2(BitsIn)
        BitsIn = BitsIn + 8
    LOOP
    BitsIn = BitsIn - CodeSize
    Code = WorkCode AND MaxCode
RETURN
ReadBufferedByte:
    IF BlockPointer > BlockSize THEN
        GOSUB GetByte: BlockSize = a%
        a$ = SPACE$(BlockSize): GET #1, , a$
        BlockPointer = 1
    END IF
    a% = ASC(MID$(a$, BlockPointer, 1)): BlockPointer = BlockPointer + 1
RETURN

END SUB

SUB Handler
'handler: handles input.
'todo: finish.
IF grab = 0 THEN

 IF lb = -1 THEN
  IF y > 453 AND states(1) = 1 THEN

   FOR tx = 1 TO abno
    IF x > 144 + (18 * tx) AND x < 160 + (18 * tx) AND y > 457 AND y < 473 THEN
     IF abfunc$(tx) = "exitgui" THEN exitgui
     IF abfunc$(tx) = "hidepanel" THEN togglepanel
    END IF
   NEXT tx
  END IF

  IF y > 453 AND states(1) = 0 THEN
   IF x > 158 AND x < 482 AND y > 473 THEN togglepanel
  END IF


 END IF

END IF

FOR id = 1 TO 50
controlstate(id) = controldown(id)
NEXT id




SELECT CASE key$                                        'key handler
 CASE CHR$(0) + "?"
  guicols(2) = guicols(2) + 1
  IF guicols(2) > 15 THEN guicols(2) = 0
  grab = 1
 CASE CHR$(0) + "@"
  guicols(3) = guicols(3) + 1
  IF guicols(3) > 15 THEN guicols(3) = 0
  grab = 1
 CASE CHR$(0) + "A"
  guicols(4) = guicols(4) + 1
  IF guicols(4) > 15 THEN guicols(4) = 0
  taskbar
END SELECT

END SUB

SUB init1
'init1: reads configuration files and sets up variables.
'todo: parse all configs.
GifLoad "gfx\boot.gif"
SLEEP 2

OPEN "ini\system.ini" FOR INPUT AS #1


Config:
INPUT #1, in$
SELECT CASE in$
 CASE "bgcolour"
  INPUT #1, guicols(1)
 CASE "screenresx"
  INPUT #1, screenresx
 CASE "screenresy"
  INPUT #1, screenresy
 CASE "active-titlecolour"
  INPUT #1, guicols(2)
 CASE "appcolour"
  INPUT #1, guicols(3)
 CASE "panelcolour"
  INPUT #1, guicols(4)
 CASE "inactive-titlecolour"
  INPUT #1, guicols(5)
END SELECT
LINE (10, 180)-(310, 195), 248, BF
Font "Reading " + in$, 10, 180, 0, "mssans", 0
waits 8



IF EOF(1) = -1 THEN CLOSE #1 ELSE GOTO Config
states(1) = 1

END SUB

SUB init2
'init2: initialises the screen, mouse, palette and autoexec files.
'finished.

SCREEN 12


OPEN "defpal.epl" FOR INPUT AS #1
FOR c = 0 TO 15
OUT &H3C8, c
INPUT #1, r
OUT &H3C9, r
INPUT #1, g
OUT &H3C9, g
INPUT #1, B
OUT &H3C9, B
NEXT c
CLOSE

LINE (0, 0)-(639, 479), guicols(1), BF

Windo 170, 165, 480, 315, "Starting up..", 1
Font "Initialising Mouse..", 172, 185, 0, "mssans", 0

FOR i% = 1 TO 57
READ a$
h$ = CHR$(VAL("&H" + a$))
MID$(mouse$, i%, 1) = h$
NEXT i%
ms% = MouseInit%
IF NOT ms% THEN SCREEN 0: PRINT "Error in init2: Mouse not found": END
MouseShow

Font "Starting appbar..", 172, 195, 0, "mssans", 0
taskbar

LINE (0, 0)-(639, 450), guicols(1), BF
Font "Edge 0.6 - " + DATE$, 0, 0, 0, "mssans", 0

MouseShow
MouseRange 0, 0, 639, 479

grab = 1

OPEN "ini\autoexec.ini" FOR INPUT AS #15
INPUT #15, noofwins

FOR n = 1 TO noofwins
INPUT #15, winap$(n)
ParseHeader winap$(n), n
putwin n
NEXT n

awin = noofwins
wins = noofwins
states(10) = 1: states(9) = 1
CLOSE #10

END SUB

DEFLNG A-Z
SUB MouseDriver (ax%, bx%, cx%, dx%)
  DEF SEG = VARSEG(mouse$)
  mouse% = SADD(mouse$)
  CALL Absolute(ax%, bx%, cx%, dx%, mouse%)
END SUB

SUB MouseHide
 ax% = 2
 MouseDriver ax%, 0, 0, 0
END SUB

FUNCTION MouseInit%
  ax% = 0
  MouseDriver ax%, 0, 0, 0
  MouseInit% = ax%
END FUNCTION

SUB MousePut (x%, y%)
  ax% = 4
  cx% = x%
  dx% = y%
  MouseDriver ax%, 0, cx%, dx%
END SUB

SUB MouseRange (x1%, y1%, x2%, y2%)
  ax% = 7
  cx% = x1%
  dx% = x2%
MouseDriver ax%, 0, cx%, dx%
  ax% = 8
  cx% = y1%
  dx% = y2%
  MouseDriver ax%, 0, cx%, dx%
END SUB

SUB MouseShow
  ax% = 1
  MouseDriver ax%, 0, 0, 0
END SUB

SUB MouseStatus (lb%, rb%, xMouse%, yMouse%)
  ax% = 3
  MouseDriver ax%, bx%, cx%, dx%
  lb% = ((bx% AND 1) <> 0)
  rb% = ((bx% AND 2) <> 0)
  xMouse% = cx%
  yMouse% = dx%
END SUB

DEFINT A-Z
SUB ParseHeader (file$, winno)
'parseheader: reads edx headers.
'finished.

OPEN file$ FOR INPUT AS #winno

INPUT #winno, winx1(winno), winy1(winno), winx2(winno), winy2(winno), wint$(winno)

CLOSE #winno



END SUB

SUB Parser (file$, winno)
'parser: interprets edge scripts (.edx).
'todo: finish all commands, variables, etc.

IF openfile(winno) = 0 THEN OPEN file$ FOR INPUT AS #winno: openfile(winno) = 1

Parse:
IF grab = 1 THEN EXIT SUB
INPUT #winno, in$
25 IF states(8 + winno) = 1 THEN
SELECT CASE in$
 CASE "Beep"
  SOUND 1000, 3
 CASE "Text"
  INPUT #winno, st$, pax, pay, pac, pafo$
  IF grab = 0 THEN Font st$, winx1(winno) + 2 + pax, winy1(winno) + 20 + pay, pac, pafo$, 0
 CASE "Showedg"
  INPUT #winno, st$, pax, pay
  IF grab = 0 THEN Viewedg st$, winx1(winno) + 2 + pax, winy1(winno) + 20 + pay
 CASE "Button"
  INPUT #winno, bid, val$, pax1, pay1, pax2, pay2
  IF grab = 0 THEN
   controlx1(bid) = winx1(winno) + 2 + pax1
   controly1(bid) = winy1(winno) + 20 + pay1
   controlx2(bid) = winx1(winno) + 2 + pax2
   controly2(bid) = winy1(winno) + 20 + pay2
   controltype(bid) = 1: controlwin(bid) = winno
   controlmsg$(bid) = val$
   drawcontrol bid
  END IF
END SELECT
END IF

IF LEFT$(in$, 11) = "Controldown" THEN
  id = VAL(MID$(in$, 13, 2))
  IF controldown(id) = 1 THEN
   posofcomma = INSTR(in$, ",")
   in$ = MID$(in$, 16, LEN(in$) - posofcomma)
   doIF = 1
   states(8 + winno) = 1
   GOTO 25
  ELSE
   doIF = 0
  END IF
END IF

IF LEFT$(in$, 9) = "Controlup" THEN
  id = VAL(MID$(in$, 11, 2))
  IF controldown(id) = 0 AND winno = awin THEN
   posofcomma = INSTR(in$, ",")
   in$ = MID$(in$, 14, LEN(in$) - posofcomma)
   doIF = 1
   states(8 + winno) = 1
   GOTO 25
  ELSE
   doIF = 0
  END IF
END IF


IF EOF(winno) = -1 THEN CLOSE winno: openfile(winno) = 0 ELSE GOTO Parse
IF states(8 + winno) = 1 THEN states(8 + winno) = 0

END SUB

SUB putline (win, ddo)
'putline: used in the window manager.
'finished.

IF ddo = 1 THEN
LINE (winx1(win), winy1(win))-(winx2(win), winy2(win)), guicols(1), BF
LINE (winx1(win), winy1(win))-(winx2(win), winy2(win)), 7, B
END IF

IF ddo = 0 THEN
LINE (winx1(win), winy1(win))-(winx2(win), winy2(win)), guicols(1), B
END IF

END SUB

SUB putwin (win)
'putwin: draws a window.
'finished.
IF awin = win THEN ifawin = 1
IF winx1(win) = 0 AND winx2(win) = 0 THEN EXIT SUB
Windo winx1(win), winy1(win), winx2(win), winy2(win), wint$(win), ifawin

END SUB

SUB taskbar
'taskbar: reads the appbars config, and draws it at the bottom.
'almost finished.
LINE (0, 453)-(639, 480), guicols(1), BF

LINE (160, 455)-(480, 479), guicols(4), BF
LINE (160, 454)-(480, 454), 7
LINE (159, 479)-(159, 454), 7
LINE (481, 479)-(481, 454), 3
LINE (158, 453)-(482, 480), 0, B

OPEN "ini\appbar.ini" FOR INPUT AS #10
INPUT #10, abno

FOR n = 1 TO abno
INPUT #10, abicons$(n), abfunc$(n)
Viewedg abicons$(n), 144 + (18 * n), 457
NEXT n




CLOSE #10

END SUB

SUB togglepanel

IF states(1) = 1 THEN states(1) = 0 ELSE states(1) = 1

SELECT CASE states(1)
 CASE 0
  MouseHide
  LINE (158, 453)-(482, 480), guicols(1), BF
  LINE (160, 475)-(480, 479), guicols(4), BF
  LINE (159, 474)-(480, 474), 7
  LINE (159, 482)-(159, 475), 7
  LINE (481, 482)-(481, 475), 3
  LINE (158, 473)-(482, 480), 0, B
  MouseShow
 CASE 1
    FOR n = 1 TO 2
     IF winy2(n) <= 453 THEN GOTO 300
     states(9) = 1: states(10) = 1
     dist = winy2(n) - 452
     winy2(n) = winy2(n) - dist: winy1(n) = winy1(n) - dist
     putwin n
     Parser winap$(n), n
300 NEXT n

    taskbar
    states(1) = 1

END SELECT
  


END SUB

SUB Viewedg (file$, vix, viy)
'viewedg: displays an EDG (edge graphic).
'finished.

vih = FREEFILE
OPEN file$ FOR INPUT AS vih
INPUT #vih, vresx, vresy

FOR viy2 = 1 TO vresy
 FOR vix2 = 1 TO vresx
  INPUT #vih, vcol
  IF vcol < 16 THEN PSET (vix + vix2, viy + viy2), vcol
 NEXT vix2
NEXT viy2

CLOSE vih



END SUB

SUB waits (time)
DEF SEG = 0
POKE (1132), 0
CountDown:
IF PEEK(1132) < time THEN GOTO CountDown
DEF SEG

END SUB

SUB Windo (x1, y1, x2, y2, title$, awon)
'windo: draws a window.
'todo: use configs so multiple styles can be used easily.


LINE (x1, y1)-(x2, y2), 0, B
LINE (x1, y1 + 18)-(x2, y1 + 18), 0

'---------- Title Segment ----------

LINE (x1 + 1, y1 + 1)-(x2 - 1, y1 + 1), 7
LINE (x1 + 1, y1 + 2)-(x1 + 1, y1 + 16), 7
LINE (x1 + 1, y1 + 17)-(x2 - 1, y1 + 17), 3
LINE (x2 - 1, y1 + 1)-(x2 - 1, y1 + 16), 3

IF awon = 1 THEN
 LINE (x1 + 2, y1 + 2)-(x2 - 2, y1 + 16), guicols(2), BF
ELSE
 LINE (x1 + 2, y1 + 2)-(x2 - 2, y1 + 16), guicols(5), BF
END IF


LINE (x2 - 17, y1 + 2)-(x2 - 17, y1 + 16), 7
LINE (x2 - 18, y1 + 2)-(x2 - 18, y1 + 16), 3

'---------- Application Segment ----------

LINE (x1 + 1, y1 + 19)-(x2 - 1, y1 + 19), 7
LINE (x1 + 1, y1 + 20)-(x1 + 1, y2 - 2), 7
LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1), 3
LINE (x2 - 1, y1 + 19)-(x2 - 1, y2 - 2), 3
LINE (x1 + 2, y1 + 20)-(x2 - 2, y2 - 2), guicols(3), BF

Font title$, x1 + 2, y1 + 2, 0, "mssans", 0


END SUB

SUB Windower
'windower: manages window movement + parser.
'todo: clean it up.

winx1(0) = winx1(awin)
winy1(0) = winy1(awin)
winx2(0) = winx2(awin)
winy2(0) = winy2(awin)

IF lb = -1 THEN
 FOR n = 0 TO 2
  IF grab = 0 AND x > winx1(n) AND x < winx2(n) - 18 AND y > winy1(n) AND y < winy1(n) + 17 THEN
   IF n <> awin AND x > winx1(awin) AND x < winx2(awin) AND y > winy1(awin) AND y < winy2(awin) THEN 150:
   grab = 1
   IF n <> 0 THEN awin = n
   distx = x - winx1(n)
   disty = y - winy1(n)
   distx2 = winx2(n) - x
   disty2 = winy2(n) - y
   P = n
   MouseHide
   putline n, 1
   EXIT FOR
  END IF

 IF grab = 0 AND n <> awin AND x > winx1(n) AND x < winx2(n) AND y > winy1(n) AND y < winy2(n) THEN
  IF x > winx1(awin) AND x < winx2(awin) AND y > winy1(awin) AND y < winy2(awin) THEN 150:
  z = n
  SWAP awin, z
  MouseHide
  states(9) = 1: states(10) = 1
  putwin z
  Parser winap$(z), z
  putwin awin
  Parser winap$(awin), awin
  MouseShow
 END IF
150 NEXT n
END IF



IF grab = 1 AND lb = -1 THEN
IF states(1) = 1 THEN MouseRange 0, 14 + disty, 639, 452 - disty2 ELSE MouseRange 0, 14 + disty, 639, 472 - disty2
 IF P = 0 THEN P = awin
  IF ox <> x OR oy <> y THEN
   putline P, 0
   winx1(P) = x - distx
   winy1(P) = y - disty
   winx2(P) = x + distx2
   winy2(P) = y + disty2
   putline P, 1
  END IF
 ox = x
 oy = y
END IF


IF lb = 0 AND grab = 1 THEN
MouseRange 0, 0, 639, 479
grab = 0
states(9) = 1: states(10) = 1
IF awin = 1 THEN z = 2 ELSE z = 1
putwin z
Parser winap$(z), z
putwin awin
Parser winap$(awin), awin
MouseShow
END IF


END SUB

